/***************************************************************************
                          nmap.cpp  -  description
                             -------------------
    begin                : mar dic 25 2001
    copyright            : (C) 2001 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <mainform.h>
#include <kfiledialog.h>
#include <qtextstream.h>
#include  <kprinter.h>
#include  <qpainter.h>
#include <qmultilineedit.h>
#include <qpaintdevicemetrics.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlineedit.h>

void MainForm::NmapSave()
{
    QString fileScan = KFileDialog::getSaveFileName(QString::null , "*" , this , "Save scan...");

	if( !fileScan.isEmpty())
	{
		QFile fileNmap(fileScan);

		if (fileNmap.open(IO_WriteOnly))
		{
			QTextStream streamNmap(&fileNmap);
			QString lineNBrowser( NBrowser->text());
			streamNmap<<lineNBrowser;
			fileNmap.close();
		}
	}

}

void MainForm::NmapScan()
{
    NScanButton->setDisabled(true);
    NSaveButton->setDisabled(true);
    NPrintButton->setDisabled(true);
    NStopButton->setEnabled(true);
    NBrowser->setText( "" );

		nmapCmd.clearArguments();

		if( NTargetCombo->currentText()=="" && !(NRandHostCheck->isChecked())) {
		
			NScanButton->setEnabled(true);
			NStopButton->setDisabled(true);
			NSaveButton->setEnabled(true);
  			NPrintButton->setEnabled(true);

			return ;

		}

		nmapCmd<<"nmap";

		switch ( NScanCombo->currentItem()) {

 				case 0:
						nmapCmd<<"-sT";
						break;
        			case 1:
						nmapCmd<<"-sS";
						break;
				case 2:
						nmapCmd<<"-sF";
						break;
        			case 3:
						nmapCmd<<"-sX";
						break;
        			case 4:
						nmapCmd<<"-sN";
						break;
        			case 5:
						nmapCmd<<"-sP";
						break;
        			case 6:
						nmapCmd<<"-sU";
						break;
				case 7:
						nmapCmd<<"-sO";
						break;
				case 8:
						nmapCmd<<"-sA";
						break;
				case 9:
						nmapCmd<<"-sW";
						break;
		}

		if ( NRPCCheck->isChecked() && NRPCCheck->isEnabled() )

				nmapCmd<<"-sR";

		switch ( NPingCombo->currentItem() ) {


				case 0:
						break;
				case 1:
						nmapCmd<<"-PT";
						break;
				case 2:
						nmapCmd<<"-PI";
						break;
				case 3:
						nmapCmd<<"-PS";
						break;
				case 4:
						nmapCmd<<"-P0";
						break;
				
		}

		switch ( NResolvCombo->currentItem() ) {

				case 0:
						break;
				case 1:
						nmapCmd<<"-R";
						break;
				case 2:
						nmapCmd<<"-n";

		}

		switch ( NTimingCombo->currentItem() ) {

				case 0:
	          break;
				case 1:
						nmapCmd<<"-T"<<"Paranoid";
						break;
				case 2:
						nmapCmd<<"-T"<<"Sneaky";
						break;
				case 3:
						nmapCmd<<"-T"<<"Polite";
						break;
				case 4:
						nmapCmd<<"-T"<<"Aggressive";
						break;
				case 5:
						nmapCmd<<"-T"<<"Insane";
						break;

		}

		if ( NRandPortCheck->isChecked() )

				nmapCmd<<"-r";

		if ( NRandHostCheck->isChecked() )

				nmapCmd<<"--randomize_hosts";

		if ( NVerbCheck->isChecked() && NVerbCheck->isEnabled() )

				nmapCmd<<"-v";

		if ( NUVerbCheck->isChecked() && NUVerbCheck->isEnabled() )

				nmapCmd<<"-d";

		if ( NOSGuessCheck->isChecked() )

				nmapCmd<<"-O";

		if ( NFragCheck->isEnabled() && NFragCheck->isChecked() )

				nmapCmd<<"-f";

		if ( NRandIPCheck->isEnabled() && NRandIPCheck->isChecked() )

				nmapCmd<<"-iR";

		if ( NFastCheck->isEnabled() && NFastCheck->isChecked() )

				nmapCmd<<"-F";

		if ( NShowCheck->isEnabled() && NShowCheck->isChecked() )

				nmapCmd<<"-I";

		if ( NTimeSpin->value() >200 ) {

				nmapCmd<<"--host_timeout";
				nmapTimeout.setNum( NTimeSpin->value() , 10 );
				nmapCmd<<nmapTimeout;

		}

		if ( NMaxRSpin->value() != 9000 ) {

				nmapCmd<<"--max_rtt_timeout";
				nmapMaxResponse.setNum( NMaxRSpin->value() , 10 );
				nmapCmd<<nmapMaxResponse;

		}

		if ( NMinRSpin->value() != 0 ) {

				nmapCmd<<"--min_rtt_timeout";
				nmapMinResponse.setNum( NMinRSpin->value() , 10 );
				nmapCmd<<nmapMinResponse;

		}

		if ( NInTimeSpin->value() != 6000 ) {

				nmapCmd<<"--initial_rtt_timeout";
				nmapInitialTimeout.setNum( NInTimeSpin->value() , 10 );
				nmapCmd<<nmapInitialTimeout;

		}

		if ( NScDelaySpin->value() != 0 ) {

				nmapCmd<<"--scan_delay";
				nmapScanDelay.setNum( NScDelaySpin->value() , 10 );
				nmapCmd<<nmapScanDelay;

		}

		if ( NPREdit->text() != "" && NPREdit->isEnabled() )

				nmapCmd<<"-p"<<NPREdit->text();

		if ( NMSSpin->value() != 0 )  {

				nmapCmd<<"-M";
				nmapMaxSockets.setNum( NMSSpin->value() , 10 );
				nmapCmd<<nmapMaxSockets;

		}

		if ( NSAEdit->text() != "" )

				nmapCmd<<"-S"<<NSAEdit->text();

		if ( NInterEdit->text() != "" )

				nmapCmd<<"-e"<<NInterEdit->text();

		if ( NSPSpin->value() != 0 && NSPSpin->isEnabled() )  {

				nmapCmd<<"-g";
				nmapSourcePort.setNum( NSPSpin->value() , 10 );
				nmapCmd<<nmapSourcePort;

		}


    		switch ( NFTPCombo->currentItem() ) {

				case 0:
						if ( NFTPEdit->isEnabled() && NFTPEdit->text() != "" )
						nmapCmd<<"-b"<<NFTPEdit->text();
						break;

				case 1:
						if ( NFTPEdit->isEnabled() && NFTPEdit->text() != "" )
								nmapCmd<<"-D"<<NFTPEdit->text();
						break;

		}

    		nmapURL = NTargetCombo->currentText();

		if ( NRandIPCheck->isChecked() && NRandIPCheck->isEnabled() )

				nmapCmd<<"-iR" ;

		else

				nmapCmd<<nmapURL;

    		nmapCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;

}

void MainForm::NmapStop()
{

    NStopButton->setDisabled( true );
    nmapCmd.kill();
    nmapOut="";
    NScanButton->setEnabled(true);
    NSaveButton->setEnabled(true);
    NPrintButton->setEnabled(true);

}

void MainForm::NmapPrint() {

    KPrinter nmapPrinter;
     nmapPrinter.setFullPage( true );
     if ( nmapPrinter.setup( this ) ) {

     		QPainter nmapPainter;
     		nmapPainter.begin( &nmapPrinter );
     		QPaintDeviceMetrics nmapMetrics( nmapPainter.device() );
     		int height = nmapMetrics.height();
         	int fontVSize=nmapPainter.fontMetrics().height();
		
     		for(int rounds= 0;rounds <= NBrowser->numLines() ; rounds ++ ) {
    		
        		nmapPainter.drawText( AlignCenter,fontVSize+=nmapPainter.fontMetrics().height(),NBrowser->textLine(rounds));

                 	if(fontVSize >= height-height/20) {

                   		nmapPrinter.newPage();
                       	 	fontVSize=nmapPainter.fontMetrics().height();

                  	}

      		}

     nmapPainter.end();

     }

}

void MainForm::nmapGetStdout(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    NBrowser->append( out );
		
}

void MainForm::nmapGetStderr(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    NBrowser->append( out );

}

void MainForm::nmapProcessEnd( KProcess *) {

    nmapCmd.kill();
    nmapOut="";
    NScanButton->setEnabled(true);
    NSaveButton->setEnabled(true);
    NStopButton->setDisabled(true);
    NPrintButton->setEnabled(true);

}

void MainForm::toggleDecoy() {

    if ( NRPCCheck->isChecked() && NFTPCombo->currentItem() == 1)

    	NFTPEdit->setDisabled( true );

    else if ( !( NRPCCheck->isChecked()) && NScanCombo->currentItem() != 0 )

	NFTPEdit->setEnabled( true );

}

void MainForm::toggleIdent_Decoy_Port() {

    if ((NScanCombo->currentItem())!=0 )  {

	NShowCheck->setDisabled( true );				
	NSPSpin->setEnabled( true );

    }

    else   {

	NShowCheck->setEnabled( true );				
	NSPSpin->setDisabled( true );

    }

    if (( NScanCombo->currentItem() == 0 ) && (NFTPCombo->currentItem()	== 1 ) )

	NFTPEdit->setDisabled( true );

    else if ( ( NScanCombo->currentItem() != 0 ) && ( NRPCCheck->isChecked()) )

	NFTPEdit->setDisabled( true );

    else

	NFTPEdit->setEnabled( true );

}

void MainForm::activateDecoy() {

    if ( (NScanCombo->currentItem() == 0) && (NFTPCombo->currentItem() == 1))

	NFTPEdit->setDisabled( true );

    else if ( (NRPCCheck->isChecked()) && (NFTPCombo->currentItem() == 1))

	NFTPEdit->setDisabled( true );

    else

	NFTPEdit->setEnabled( true );

}

void MainForm::toggleVerbose() {

    if ( NUVerbCheck->isEnabled())

	NUVerbCheck->setDisabled( true );

    else

	NUVerbCheck->setEnabled( true );

}

void MainForm::toggleUltraVerbose() {

    if ( NVerbCheck->isEnabled())

	NVerbCheck->setDisabled( true );

    else

	NVerbCheck->setEnabled( true );

}

void MainForm::togglePorts() {

    if ( NFastCheck->isChecked())

	NPREdit->setDisabled( true );

    else

	NPREdit->setEnabled( true );

}

void MainForm::toggleTarget() {

    if ( NRandIPCheck->isChecked())

	NTargetCombo->setDisabled( true );
		
    else

	NTargetCombo->setEnabled( true );

}

void MainForm::toggleFragment() {

    if ((NScanCombo->currentItem() >= 1 ) && ( NScanCombo->currentItem() <= 5 ) || (NScanCombo->currentItem() >= 8 ))

	NFragCheck->setEnabled( true );

    else

	NFragCheck->setDisabled( true );

}

