/***************************************************************************
                          ping.cpp  -  description
                             -------------------
    begin                : mar dic 25 2001
    copyright            : (C) 2001 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <mainform.h>
#include <kprocess.h>
#include <kfiledialog.h>
#include <qtextstream.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include <qmultilineedit.h>
#include  <kprinter.h>
#include  <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qcombobox.h>
#include <knuminput.h>

 void MainForm::Ping() {

    PPingButton->setDisabled(true);
    PSaveButton->setDisabled(true);
    PStopButton->setEnabled(true);
    PPrintButton->setDisabled(true);
    PBrowser->setText( "" );
    pingCmd.clearArguments();

    if( PTargetCombo->currentText()=="") {

	PPingButton->setEnabled(true);
	PStopButton->setDisabled(true);
	PSaveButton->setEnabled(true);
 	PPrintButton->setEnabled(true);

	return ;

    }

    pingURL = PTargetCombo->currentText();
    pingCmd<<"ping"<<pingURL ;

    if( PEchoesSpin->value()!=0) {

	pingEchoes.setNum(  PEchoesSpin->value(), 10 );
	pingCmd<<"-c"<<pingEchoes;

    }
		
    if(( PEDelSpin->value()!=0 ) && ( PEDelSpin->isEnabled())) {

	pingDelay.setNum(  PEDelSpin->value(), 10 );
	pingCmd<<"-i"<<pingDelay;

    }

    if( ( PFloodSpin->value()!=0) && ( PFloodSpin->isEnabled())) {

	pingFloodPackets.setNum(  PFloodSpin->value(), 10 );
	pingCmd<<"-l"<<pingFloodPackets;

    }

    if( PPadSpin->value()!=0) {

	pingPad.setNum(  PPadSpin->value(), 16 );
	pingCmd<<"-p"<<pingPad;

    }

    if( POctSpin->value()!=0) {

	pingOctets.setNum(  POctSpin->value(), 10 );
	pingCmd<<"-s"<<pingOctets;

    }

    if( PPingTimeSpin->value()!=0) {
			
    	pingTime.setNum(  PPingTimeSpin->value(), 10 );
	pingCmd<<"-w"<<pingTime;

    }

    if( PSODEBCheck->isChecked() == true ) pingCmd<<"-d" ;
    if( PFloodCheck->isChecked() == true ) pingCmd<<"-f" ;
    if( PNumCheck->isChecked() == true ) pingCmd<<"-n" ;
    if( PQuietCheck->isChecked() == true ) pingCmd<<"-q" ;
    if( PRecRouteCheck->isChecked() == true ) pingCmd<<"-R" ;
    if( PBypCheck->isChecked() == true ) pingCmd<<"-r" ;
    if( PVerbCheck->isChecked() == true ) pingCmd<<"-v" ;

    pingCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;

}

void MainForm::PingPrint() {

    KPrinter pingPrinter;
     pingPrinter.setFullPage( true );
     if ( pingPrinter.setup( this ) ) {

     		QPainter pingPainter;
     		pingPainter.begin( &pingPrinter );
     		QPaintDeviceMetrics pingMetrics( pingPainter.device() );
     		int height = pingMetrics.height();
         	int fontVSize=pingPainter.fontMetrics().height();
		
     		for(int rounds= 0;rounds <= PBrowser->numLines() ; rounds ++ ) {
    		
        		pingPainter.drawText( AlignCenter,fontVSize+=pingPainter.fontMetrics().height(),PBrowser->textLine(rounds));

                 	if(fontVSize >= height-height/20) {

                   		pingPrinter.newPage();
                       	 	fontVSize=pingPainter.fontMetrics().height();

                  	}

      		}

     pingPainter.end();

     }

}

void MainForm::PingSave()
{
    QString filePing = KFileDialog::getSaveFileName( QString::null , "*" , this , "Save ping...");

	if( !filePing.isEmpty()) {

		QFile fileEchoes(filePing);

		if (fileEchoes.open(IO_WriteOnly)) {

			QTextStream streamPing(&fileEchoes);
			QString linePBrowser( PBrowser->text());
			streamPing<<linePBrowser;
			fileEchoes.close();

		}

	}

}

void MainForm::PingStop()
{
    PStopButton->setDisabled( true );
    pingCmd.kill();
    pingOut="";
    PPingButton->setEnabled(true);
    PSaveButton->setEnabled(true);
    PPrintButton->setEnabled(true);

}

void MainForm::pingGetStdout(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    PBrowser->append( out );

}

void MainForm::pingGetStderr(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    PBrowser->append( out );

}

void MainForm::pingProcessEnd( KProcess *) {

    pingCmd.kill();
    pingOut="";
    PPingButton->setEnabled(true);
    PSaveButton->setEnabled(true);
    PStopButton->setDisabled(true);
    PPrintButton->setEnabled(true);

}

void MainForm::toggleTimeFlood() {

    if( PFloodCheck->isChecked()) {

          PEDelSpin->setDisabled( true );
          PFloodSpin->setDisabled( true );

    }
 				
    else {

          PEDelSpin->setEnabled( true );
          PFloodSpin->setEnabled( true );

    }

}

void MainForm::toggleFloodTime() {

    if( PEchoesSpin->value()!=0 ) {

          PPingTimeSpin->setDisabled( true );
          PFloodCheck->setDisabled( true );

    }

    else {

          PPingTimeSpin->setEnabled( true );
          PFloodCheck->setEnabled( true );

    }

}

void MainForm::toggleQuiet() {

    if( PVerbCheck->isChecked())

        PQuietCheck->setDisabled( true );

    else

    	PQuietCheck->setEnabled( true );

}

