/***************************************************************************
                          traceroute.cpp  -  description
                             -------------------
    begin                : mar dic 25 2001
    copyright            : (C) 2001 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <mainform.h>
#include <kfiledialog.h>
#include <qtextstream.h>
#include  <kprinter.h>
#include  <qpainter.h>
#include <qmultilineedit.h>
#include <qpaintdevicemetrics.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>

void MainForm::TracePrint() {

    KPrinter tracePrinter;
    tracePrinter.setFullPage( true );
     if ( tracePrinter.setup( this ) ) {

     		QPainter tracePainter;
     		tracePainter.begin( &tracePrinter );
     		QPaintDeviceMetrics traceMetrics( tracePainter.device() );
     		int height = traceMetrics.height();
         	int fontVSize=tracePainter.fontMetrics().height();
		
     		for(int rounds= 0;rounds <= TBrowser->numLines() ; rounds ++ ) {
    		
        		tracePainter.drawText( AlignCenter,fontVSize+=tracePainter.fontMetrics().height(),TBrowser->textLine(rounds));

                 	if(fontVSize >= height-height/20) {

                   		tracePrinter.newPage();
                       	 	fontVSize=tracePainter.fontMetrics().height();

                  	}

      		}

     tracePainter.end();

     }

}

void MainForm::TraceRoute() {

    TTraceButton->setDisabled(true);
    TSaveButton->setDisabled(true);
    TPrintButton->setDisabled(true);
    TStopButton->setEnabled(true);
    TBrowser->setText( "" );
    traceCmd.clearArguments();

    if( TTargetCombo->currentText()=="") {

    TTraceButton->setEnabled(true);
    TStopButton->setDisabled(true);
    TSaveButton->setEnabled(true);
    TPrintButton->setEnabled(true);

    return ;

    }

    traceURL = TTargetCombo->currentText();
    traceCmd<<"traceroute"<<traceURL ;

    if( TSourceCombo->currentText() !="" ) {

    	traceSource = TSourceCombo->currentText();
	   traceCmd<<"-s"<<traceSource;

    }

    if( TGateCombo->currentText() !="" ) {

		traceGateway = TGateCombo->currentText();
		traceCmd<<"-g"<<traceGateway;

    }

    if( TInterCombo->currentText() !="" ) {

		traceInterface = TInterCombo->currentText();
		traceCmd<<"-i"<<traceInterface;

    }

    if( TInitSpin->value()!=0) {

		traceTInit.setNum( TInitSpin->value(), 10 );
		traceCmd<<"-f"<<traceTInit;

    }

    if( TMaxSpin->value()!=0 ) {

		traceMaxTTL.setNum( TMaxSpin->value(), 10 );
		traceCmd<<"-m"<<traceMaxTTL;

    }

   if( TNQSpin->value()!=0) {

		traceNqueries.setNum( TNQSpin->value(), 10 );
		traceCmd<<"-q"<<traceNqueries;

    }

    if( TPortSpin->value()!=0) {

		tracePort.setNum(  TPortSpin->value(), 10 );
		traceCmd<<"-p"<<tracePort;

    }

    if( TTOSSpin->value()!=0) {

		traceTos.setNum( TTOSSpin->value(), 10 );
		traceCmd<<"-t"<<traceTos;

    }

    if( TPauseSpin->value()!=0) {

		tracePause.setNum( TPauseSpin->value(), 10 );
		traceCmd<<"-z"<<tracePause;

    }

    if( TWaitSpin->value()!=0) {

		traceWait.setNum( TWaitSpin->value(), 10 );
		traceCmd<<"-w"<<traceWait;

    }

    if( TDontCheck->isChecked() == true ) traceCmd<<"-F" ;
    if( TSocketCheck->isChecked() == true ) traceCmd<<"-d" ;
    if( TICMPCheck->isChecked() == true ) traceCmd<<"-I" ;
    if( TNUMCheck->isChecked() == true ) traceCmd<<"-n" ;
    if( TBypCheck->isChecked() == true ) traceCmd<<"-r" ;
    if( TVerbCheck->isChecked() == true ) traceCmd<<"-v" ;
    if( TToggleCheck->isChecked() == true ) traceCmd<<"-x" ;

    traceCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;

}

void MainForm::TraceSave() {

    QString fileTrace = KFileDialog::getSaveFileName( QString::null , "*" , this , "Save trace...");

    if( !fileTrace.isEmpty()) {

	QFile fileTRoute(fileTrace);

	if (fileTRoute.open(IO_WriteOnly)) {

		QTextStream streamTrace(&fileTRoute);
		QString lineTBrowser( TBrowser->text());
		streamTrace<<lineTBrowser;
		fileTRoute.close();

	}

   }

}

void MainForm::TraceStop() {

    TStopButton->setDisabled( true );
    traceCmd.kill();
    traceOut="";
    TTraceButton->setEnabled(true);
    TSaveButton->setEnabled(true);
    TPrintButton->setEnabled(true);

}

void MainForm::traceGetStdout(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    TBrowser->append( out );

}

void MainForm::traceGetStderr(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    TBrowser->append( out );

}

void MainForm::traceProcessEnd( KProcess *) {

    traceCmd.kill();
    traceOut="";
    TTraceButton->setEnabled(true);
    TSaveButton->setEnabled(true);
    TStopButton->setDisabled(true);
    TPrintButton->setEnabled(true);

}
