/***************************************************************************
                          whois.cpp  -  description
                             -------------------
    begin                : mar dic 25 2001
    copyright            : (C) 2001 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <mainform.h>
#include <kfiledialog.h>
#include <qtextstream.h>
#include  <kprinter.h>
#include  <qpainter.h>
#include <qmultilineedit.h>
#include <qpaintdevicemetrics.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>


 void MainForm::Whois()
{
    WQueryButton->setDisabled(true);
    WSaveButton->setDisabled(true);
    WPrintButton->setDisabled(true);
    WStopButton->setEnabled(true);
    WBrowser->setText( "" );
    whoisCmd.clearArguments();

    if( WObjectCombo->currentText()=="") {

    WQueryButton->setEnabled(true);
    WStopButton->setDisabled(true);
    WSaveButton->setEnabled(true);
    WPrintButton->setEnabled(true);

    return ;

    }

    whoisURL = WObjectCombo->currentText();
    whoisCmd<<"whois"<<whoisURL ;

    if( WServerCombo->currentText() !="" ) {

    	whoisServer = WServerCombo->currentText();
	   whoisCmd<<"-h"<<whoisServer;

    }

    if( WPortSpin->value()!=0 && WServerCombo->currentText() !="" ) {

		whoisPort.setNum( WPortSpin->value(), 10 );
		whoisCmd<<"-p"<<whoisPort;

    }

    if( WLegalCheck->isChecked() == true ) traceCmd<<"-H" ;
    if( WVerbCheck->isChecked() == true ) traceCmd<<"-V" ;
    if( WFastCheck->isChecked() == true ) traceCmd<<"-F" ;
    if( WExactCheck->isChecked() == true ) traceCmd<<"-x" ;
    if( WOneLessCheck->isChecked() == true ) traceCmd<<"-l" ;
    if( WAllLessCheck->isChecked() == true ) traceCmd<<"-L" ;
    if( WAllMoreCheck->isChecked() == true ) traceCmd<<"-M" ;
    if( WFirstMoreCheck->isChecked() == true ) traceCmd<<"-m" ;
    if( WNoRecursCheck->isChecked() == true ) traceCmd<<"-r" ;
    if( WShowLocalCheck->isChecked() == true ) traceCmd<<"-R" ;
    if( WLeaveSyntCheck->isChecked() == true ) traceCmd<<"-S" ;
    if( WDNSDelegat->isChecked() == true ) traceCmd<<"-d" ;
    if( WPrimaryCheck->isChecked() == true ) traceCmd<<"-K" ;

    whoisCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;
}

void MainForm::WhoisSave()
{
    QString fileWhois = KFileDialog::getSaveFileName( QString::null , "*" , this , "Save whois...");

    if( !fileWhois.isEmpty()) {

	QFile fileWQuery(fileWhois);

	if (fileWQuery.open(IO_WriteOnly)) {

		QTextStream streamWhois(&fileWQuery);
		QString lineWBrowser( WBrowser->text());
		streamWhois<<lineWBrowser;
		fileWQuery.close();

	}

   }
}

void MainForm::WhoisStop()
{
    WStopButton->setDisabled( true );
    whoisCmd.kill();
    whoisOut="";
    WQueryButton->setEnabled(true);
    WSaveButton->setEnabled(true);
    WPrintButton->setEnabled(true);
}

void MainForm::WhoisPrint()
{
    KPrinter whoisPrinter;
    whoisPrinter.setFullPage( true );
     if ( whoisPrinter.setup( this ) ) {

     		QPainter whoisPainter;
     		whoisPainter.begin( &whoisPrinter );
     		QPaintDeviceMetrics whoisMetrics( whoisPainter.device() );
     		int height = whoisMetrics.height();
         	int fontVSize=whoisPainter.fontMetrics().height();
		
     		for(int rounds= 0;rounds <= WBrowser->numLines() ; rounds ++ ) {
    		
        		whoisPainter.drawText( AlignCenter,fontVSize+=whoisPainter.fontMetrics().height(),WBrowser->textLine(rounds));

                 	if(fontVSize >= height-height/20) {

                   		whoisPrinter.newPage();
                       	 	fontVSize=whoisPainter.fontMetrics().height();

                  	}

      		}

     whoisPainter.end();

     }

}

void MainForm::whoisGetStdout(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    WBrowser->append( out );

}

void MainForm::whoisGetStderr(KProcess *proc, char *buffer, int buflen ) {

    QString out(buffer);
    out.truncate(buflen);
    WBrowser->append( out );

}

void MainForm::whoisProcessEnd( KProcess *) {

    whoisCmd.kill();
    whoisOut="";
    WQueryButton->setEnabled(true);
    WSaveButton->setEnabled(true);
    WStopButton->setDisabled(true);
    WPrintButton->setEnabled(true);

}
